﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class VihollistenLuoja : MonoBehaviour {

    // Luodaan taulukko mahdollisista syntymiskohdista.
    // Valitaan tyypiksi Transform, koska tarvitsemme tietää sen sijainnin ja asennon maailmassa.
    // Taulukon jäsenet ovat indeksoitu nollasta (0) lähtien.
    // Tämä taulukko täytetään inspektorista.
    public Transform[] syntymiskohdat;

    // Luodaan taulukko, johon tallennetaan viittaukset eri vihollisten prefabeille.
    // Prefabia käytetään kun haluamme lisätä pelin aikana maailmaan objekteja.
    // Valitaan taulukon tyypiksi GameObject.
    // Tämä taulukko täytetään inspektorista.
    public GameObject[] vihollistenPrefabit;

    // Voidaksemme luoda uusia vihollisia tietyn väliajoin, pitää viimeksi luodun vihollisen luomisajankohta olla tiedossa.
    float viimeksiLuodunAjankohta;
	
	void Update () {
        // Kirjoitetaan if-ehtolauseen sisään ehto, jonka toteuduttua luomme maailmaan yhden vihollisen lisää.
        // Ajan, joka on kulunut viime vihollisen luonnista, saadaan vähentämällä Time.time arvosta viimeksiLuodunAjankohta-muuttujan arvo.
        // Time.time palauttaa sekunteina ajan, jonka peli on ollut käynnissä. Ehto toteutuu, jos tämä erotus on suurempi kuin kolmonen (3).
        if (Time.time - viimeksiLuodunAjankohta > 3f)
        {
            //Ehdon toteutuessa kutsutaan luomamme LuoUusiVihollinen-funktio.
            LuoUusiVihollinen();
        }
	}

    // Luodaan oma funktio vihollisen luomiselle. Funktioiden avulla koodi selkeytyy.
    // Valitaan funktion palautustyypiksi void, eli funktio ei palauta mitään arvoa sen kutsuttua.
    void LuoUusiVihollinen()
    {
        // Valitaan satunnainen syntymiskohta mahdollisista syntymiskohdista, jotka on lisätty taulukkoon inspektorista.
        // Taulukon tietyn jäsenen saa kirjoittamalla sen indeksin hakasulkeiden [] väliin taulukon nimen perään.
        // Random.Range-funktio palauttaa satunnaisen numeron kahden väliltä. Ensimmäinen parametri on mukaanlukeva alaraja ja toinen on poissulkeva yläraja.
        // Huomaa, että kyseinen funktio palauttaa siis maksimissaan ylärajaa yhtä pienemmän luvun.
        /// ESIM:
        /// Jos taulukossamme on 4 jäsentä, on niiden indeksit 0, 1, 2 ja 3.
        /// Asettamalla Random.Range-funktion ylärajaksi taulukon jäsenten määrän, joka saadaan kirjoittamalla taulukon nimen perään .Length,
        /// palauttaa kyseinen funktio siis korkeintaan arvon 3 (4 - 1 = 3). Näin tulemme siis saamaan taulukon rajoissa olevan luvun.
        Transform kohta = syntymiskohdat[Random.Range(0, syntymiskohdat.Length)];

        // Käytetään samaa tekniikkaa satunnaisen vihollisen valitsemiseen.
        GameObject vihollinen = vihollistenPrefabit[Random.Range(0, vihollistenPrefabit.Length)];

        // Instantiate-funktio luo maailmaan objektin.
        // Ensimmäinen parametri on objektin prefab ja kaksi viimeistä sen sijainti ja asento, jotka sille asetetaan luonnin yhteydessä.
        Instantiate(vihollinen, kohta.position, kohta.rotation);

        // Lopuksi asetetaan viimeksiLuodunAjankohta-muuttujan arvoksi tämänhetkinen Time.time-arvo välttääksemme jatkuvaa vihollisten luomista ilman väliaikaa.
        viimeksiLuodunAjankohta = Time.time;
    }

}
